Bug 844314 - Review Request: codenarc - Groovy library that provides static analysis features for Groovy code
Review Request: codenarc - Groovy library that provides static analysis featu...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Marek Goldmann
Fedora Extras Quality Assurance
:
Depends On: 844299
Blocks: 809950
  Show dependency treegraph
 
Reported: 2012-07-30 05:31 EDT by gil cattaneo
Modified: 2012-08-17 21:22 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-17 21:22:08 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mgoldman: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description gil cattaneo 2012-07-30 05:31:28 EDT
Spec URL: http://gil.fedorapeople.org/codenarc.spec
SRPM URL: http://gil.fedorapeople.org/codenarc-0.17-1.fc16.src.rpm
Description: CodeNarc is a static analysis tool for Groovy source code,
enabling monitoring and enforcement of many coding standards
and best practices. CodeNarc applies a set of Rules
(predefined and/or custom) that are applied to each Groovy
file, and generates an HTML report of the results, including
a list of rules violated for each source file, and a count
of the number of violations per package and for the whole
project.
Fedora Account System Username: gil
Comment 1 Mikolaj Izdebski 2012-08-02 09:39:52 EDT
I am taking this review.
Comment 2 Mikolaj Izdebski 2012-08-02 09:51:33 EDT
Oops, I didn't notice this review depended on 2 others. Stepping back, sorry.
Comment 3 Marek Goldmann 2012-08-06 07:01:02 EDT
I'm taking this for review, but dropping gmaven requirement.
Comment 4 Marek Goldmann 2012-08-06 07:35:03 EDT
Package Review
==============

Key:
- = N/A
x = Check
! = Problem
? = Not evaluated

=== REQUIRED ITEMS ===
[!]  Rpmlint output:

0 packages and 1 specfiles checked; 0 errors, 0 warnings.
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
codenarc.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/codenarc-0.17/NOTICE.txt
codenarc.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/codenarc-0.17/LICENSE.txt
codenarc.noarch: W: spurious-executable-perm /usr/share/doc/codenarc-0.17/README.txt
codenarc.noarch: E: wrong-script-end-of-line-encoding /usr/share/doc/codenarc-0.17/README.txt
1 packages and 0 specfiles checked; 1 errors, 3 warnings

Seee issue #1.

[x]  Package is named according to the Package Naming Guidelines[1].
[x]  Spec file name must match the base package name, in the format %{name}.spec.
[x]  Package meets the Packaging Guidelines[2].
[x]  Package successfully compiles and builds into binary rpms.
[x]  Buildroot definition is not present
[x]  Package is licensed with an open-source compatible license and meets other legal requirements as defined in the legal section of Packaging Guidelines[3,4].
[x]  License field in the package spec file matches the actual license.
License type: ASL 2.0
[x]  If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package is included in %doc.
[x]  All independent sub-packages have license of their own
[x]  Spec file is legible and written in American English.
[x]  Sources used to build the package matches the upstream source, as provided in the spec URL.
MD5SUM this package    : a986ae23279ea0d1e8f5e5d11646f8dd
MD5SUM upstream package: a986ae23279ea0d1e8f5e5d11646f8dd
[x]  All build dependencies are listed in BuildRequires, except for any that are listed in the exceptions section of Packaging Guidelines[5].
[x]  Package must own all directories that it creates or must require other packages for directories it uses.
[x]  Package does not contain duplicates in %files.
[x]  File sections do not contain %defattr(-,root,root,-) unless changed with good reason
[!]  Permissions on files are set properly.

See *.txt issues descrived in #1.

[X]  Package does NOT have a %clean section which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). (not needed anymore)
[x]  Package consistently uses macros (no %{buildroot} and $RPM_BUILD_ROOT mixing)
[x]  Package contains code, or permissable content.
[x]  Fully versioned dependency in subpackages, if present.
[-]  Package contains a properly installed %{name}.desktop file if it is a GUI application.
[x]  Package does not own files or directories owned by other packages.
[!]  Javadoc documentation files are generated and included in -javadoc subpackage

We cannot generate javadocs because of groovydoc issues. Additionally we cannot use javadoc task from Ant, because some source is in groovy language and the javadoc build fails. Onse we'll have gmaven, it;ll be possible to generate 

[-]  Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlinks)
[x]  Packages have proper BuildRequires/Requires on jpackage-utils
[-]  Javadoc subpackages have Require: jpackage-utils
[x]  Package uses %global not %define
[-]  If package uses tarball from VCS include comment how to re-create that tarball (svn export URL, git clone URL, ...)
[x]  If source tarball includes bundled jar/class files these need to be removed prior to building
[x]  All filenames in rpm packages must be valid UTF-8.
[x]  Jar files are installed to %{_javadir}/%{name}.jar (see [6] for details)
[x]  If package contains pom.xml files install it (including depmaps) even when building with ant
[x]  pom files has correct add_maven_depmap

=== Maven ===
[x]  Use %{_mavenpomdir} macro for placing pom files instead of %{_datadir}/maven2/poms
[-]  If package uses "-Dmaven.test.skip=true" explain why it was needed in a comment
[-]  If package uses custom depmap "-Dmaven.local.depmap.file=*" explain why it's needed in a comment
[x]  Package DOES NOT use %update_maven_depmap in %post/%postun
[x]  Packages DOES NOT have Requires(post) and Requires(postun) on jpackage-utils for %update_maven_depmap macro

=== Other suggestions ===
[-]  If possible use upstream build method (maven/ant/javac)
[x]  Avoid having BuildRequires on exact NVR unless necessary
[x]  Package has BuildArch: noarch (if possible)
[x]  Latest version is packaged.
[x]  Reviewer should test that the package builds in mock.
Tested on:

Locally with gmetrics available.

=== Issues ===
1. Please fix the permissions and encoding on *.txt files.
2. Please install the jar into codenarc.jar instead CodeNarc.jar. I don't think the CodeNarc.jar symlink is required at all.
Comment 5 gil cattaneo 2012-08-06 08:07:02 EDT
Spec URL: http://gil.fedorapeople.org/codenarc/1/codenarc.spec
SRPM URL: http://gil.fedorapeople.org/codenarc/1/codenarc-0.17-2.fc16.src.rpm
- fixed the permissions and encoding issues on *.txt files
- change with_gmaven to 0 (only for now)
- generate javadocs with ant support
Comment 6 Marek Goldmann 2012-08-06 08:59:10 EDT
Looks good now, APPROVED!
Comment 7 gil cattaneo 2012-08-06 09:54:31 EDT
New Package SCM Request
=======================
Package Name: codenarc
Short Description: Groovy library that provides static analysis features for Groovy code
Owners: gil
Branches: f17
InitialCC: java-sig
Comment 8 Gwyn Ciesla 2012-08-06 10:17:26 EDT
Git done (by process-git-requests).
Comment 9 Fedora Update System 2012-08-06 14:37:45 EDT
codenarc-0.17-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/codenarc-0.17-2.fc17
Comment 10 Fedora Update System 2012-08-09 19:28:00 EDT
codenarc-0.17-2.fc17 has been pushed to the Fedora 17 testing repository.
Comment 11 Fedora Update System 2012-08-17 21:22:08 EDT
codenarc-0.17-2.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.